import { HttpRequest, HttpResponse, HttpResult } from "../types";
import { CookieManager, FileManager } from "../models";
import { SessionProvider, Controller } from ".";

export abstract class Guard implements Controller {
    request: HttpRequest;
    response: HttpResponse;
    query: { [key: string]: string };
    body: { [key: string]: any };
    session: SessionProvider;
    cookie: CookieManager;
    param?: { [key: string]: string };
    data: { [key: string]: any };
    file: FileManager;
    abstract check(...args): Promise<HttpResult>;

    constructor(...args) {

    }
}